



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LoadRunner（一）——性能测试基础及性能指标概述</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LoadRunner（一）——性能测试基础及性能指标概述</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 15:05:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>参考学习感谢：《精通软件性能测试与LoadRunner实战》</p>
<p>一、典型的性能测试场景</p>
<ol><li>某个产品要发布了，需要对全市的用户做集中培训。通常在进行培训的时候，老师讲解完成一个业务以后，被培训用户会按照老师讲解的实例同步操作前面讲过的业务操作。这样存在用户并发的问题，我们在培训之前需要考虑被培训用户的人数在场景中设计酌情设置并发用户数量。</li>
<li><p>同一系统可以采用两种构架：Java、.Net，决定用哪个。同样的系统用不同的语言、框架实现效果也会有所不同。为了系统能够有更好的性能，在系统实现前期，可以考虑设计一个小的Demo，设计同样的场景，实际考察不同语言、不同框架之间的性能差异，而后选择性能好的语言、框架开发软件产品。</p></li>
<li><p>一门户网站能够支持多少用户并发操作（注册、写博客、看照片、灌水&hellip;&hellip;)。一个门户网站应该是经得起考验的。根据预期的用户量设计相应用户的并发量，同时一个好的网站由于随着用户的逐渐增长以及推广的深入，访问量可能会成数量级的增长。考虑门户网站这些方面的特点，在进行性能测试的时候也需要考虑可靠性测试、失败测试以及安全性测试等。</p></li></ol>
<p>二、功能测试与性能测试关系</p>
<p>功能测试和性能测试是相辅相成的，对于一款优秀的软件产品来讲，它们是不可减少的2个重要测试环节； 要因地制宜，结合实际需求，选择合适的时间点进行，减少不必要的人力、物力浪费，才能实现利益最大化。</p>
<p>三、性能测试的概念及其分类</p>
<ol><li>性能测试</li>
<li>负载测试</li>
<li>压力测试</li>
<li>配置测试</li>
<li>并发测试</li>
<li>容量测试</li>
<li>可靠性测试</li>
<li>失败测试</li></ol>
<p>概念及其分类</p>
<ol><li><p>系统的性能是一个很大的概念，覆盖面非常广泛，对一个软件系统而言，包括：执行效率、资源占用、系统稳定性、安全性、兼容性、可靠性、可扩展性等。性能测试是为描述测试对象与性能相关的特征并对其进行评价，而实施和执行的一类测试。它主要通过自动化的测试工具模拟多种正常、峰值以及异常负载条件来对系统的各项性能指标进行测试。通常大家把性能测试、负载测试、压力测试等统称为性能测试。</p></li>
<li><p>负载测试：通过逐步增加系统负载，测试系统性能的变化，并最终确定在满足系统的性能指标情况下，系统所能够承受的最大负载量的测试。简而言之，负载测试是通过逐步加压的方式来确定系统的处理能力、确定系统能够承受的各项阀值。例如：逐步加压，从而得到&ldquo;响应时间不超过10秒&rdquo;、&ldquo;服务器平均CPU利用率低于85%&rdquo;等指标的阈值。</p></li>
<li><p>压力测试：通过逐步增加系统负载，测试系统性能的变化，并最终确定在什么负载条件下系统性能处于失效状态，并来获得系统能提供的最大服务级别的测试。压力测试是逐步增加负载，使系统某些资源达到饱和甚至失效。</p></li>
<li>配置测试：主要是通过对被测试软件的软硬件配置的测试，找到系统各项资源的最优分配原则。配置测试能充分利用有限的软硬件资源，发挥系统的最佳处理能力，同时可以将其同其它性能测试类型联合应用，从而为系统调优提供重要依据。</li>
<li><p>并发测试：测试多个用户同时访问同一个应用、同一个模块或者数据记录时是否存在死锁或者其他性能问题，几乎所有的性能测试都会涉及一些并发测试。&nbsp;因并发测试对时间的要求比较苛刻，通常并发用户的模拟都是借助于工具，采用多线程或多进程方式来模拟多个虚拟用户的并发性操作，在后续讲LoadRunner 工具时，有一个集合点的概念，它就是用来模拟并发的，您可以在VuGen中设置集合点，在Controller中设置其对应的策略，来模拟用例设计的场景。</p></li>
<li><p>容量测试：在一定的软、硬件条件下，在数据库中构造不同数量级的记录数量，通过运行一种或多种业务场景在一定虚拟用户数量的情况下，获取不同数量级别的性能指标从而得到数据库能够处理的最大会话能力、最大容量等。确定系统可处理同时在线的最大用户数，通常和数据库有关。</p></li>
<li>可靠性测试：通过给系统加载一定的业务压力（如CPU资源在70%～90%的使用率）的情况下，运行一段时间，检查系统是否稳定。因为运行时间较长，通常可以测试出系统是否有内存泄露等问题。
<p>通常我们不可能做一次可靠性测试执行１年时间，所以多数情况下，可靠性测试是执行一段时间，如：24小时、3&times;24小时或7&times;24小时来模拟长时间运行。</p></li>
<li>失败测试：对于有冗余备份和负载均衡的系统，通过这样的测试来检验如果系统局部发生故障用户是否能够继续使用系统，用户受到多大的影响。如：几台机器做均衡负载，一台或几台机器垮掉后系统能够承受的压力。</li></ol>
<p>四、性能指标及相关计算公式</p>
<ol><li>吞吐量</li>
<li>并发数</li>
<li>思考时间</li>
<li>响应时间</li>
<li>点击数</li>
<li>资源利用率</li>
<li>网络吞吐量</li>
<li>错误率</li>
<li>系统稳定性</li></ol>
<p>具体：</p>
<ol><li>吞吐量（Throughput）：指的是单位时间内处理的客户端请求数量，直接体现软件系统的性能承载能力。通常情况下，吞吐量用&ldquo;请求数/秒&rdquo;或者&ldquo;页面数/秒&rdquo;来衡量。从业务角度来看，吞吐量也可以用&ldquo;业务数/小时&rdquo;、&ldquo;业务数/天&rdquo;、&ldquo;访问人数/天&rdquo;、&ldquo;页面访问量/天&rdquo;来衡量。从网络角度来看，还可以用&ldquo;字节数/小时&rdquo;、&ldquo;字节数/天&rdquo;等来衡量网络的流量。</li>
<li><p>并发（Concurrency）：它最简单的描述就是指多个同时发生的业务操作。例如，100个用户同时单击登录页面的&ldquo;登录&rdquo;按钮操作。通常，应用系统会随着用户同时应用某个具体的模块，而导致资源的争用问题，例如，50个用户同时执行统计分析的操作，由于统计业务涉及很多数据提取以及科学计算问题，所以这个时候很有可能内存和CPU会出现瓶颈。并发性测试描述的是多个客户端同时向服务器发出请求，考察服务器端承受能力的一种性能测试方式。</p></li>
<li><p>思考时间（Think Time）：它就是在录制脚本过程中，每个请求之间的时间间隔，也就是操作过程中停顿的时间。为了真实地描述用户操作的实际场景，在录制脚本的过程中，通常，LoadRunner也会录制这些思考时间，在脚本中lr_think_time()函数就是实现前面所说的思考时间，它实现了在两个请求之间的停顿。</p></li>
<li>响应时间指用户从客户端发起一个请求开始，到客户端接收到从服务器端返回结果的响应结束，结果信息展现在客户端，整个过程所耗费的时间。</li>
<li><p>点击数是衡量Web服务器处理能力的一个重要指标。它的统计是客户端向Web服务器发了多少次HTTP请求计算的。这里需要说明的是，点击数不是通常一般人认为的访问一个页面就是１次点击数，点击数是该页面包含的元素（如：图片、链接、框架等）向Web服务器发出的请求数数量。通常我们也用每秒点击次数（Hits per Second）指标来衡量Web服务器的处理能力。</p></li>
<li>资源利用率，是指系统各种资源的使用情况，一般用&ldquo;资源的使用量/总的资源可用量&times;100%&rdquo;形成资源利用率的数据。通常，系统资源的利用率，结合不同行业系统的需求也有所不同，例如，在银行行业对系统的稳定要求比较严格，结合CPU利用率来讲，其要求不高于60％，而其他行业的系统要求不是很严格CPU利用率不高80%即可。</li>
<li>网络吞吐量是指在网络工作正常的情况下单位时间内通过的网络的数据数量。通常，该指标用于衡量系统对于网络设备或链路传输能力的需求。当网络吞吐量指标接近网络设备或链路最大传输能力时，则需要考虑升级网络设备，以提升网络处理吞吐量。</li>
<li><p>错误率指系统在负载情况下，失败交易的概率。错误率＝(失败交易数/交易总数)*100%。不同系统对错误率的要求不同，但一般不超出千分之五。稳定性较好的系统，其错误率应该由超时引起，即为超时率。</p></li>
<li>系统稳定性：基于系统本身的重要性，通常要求非常高，要求365&times;24小时无故障运行，通常系统稳定性关注的内容是稳定运行时间，该指标表示系统在标准压力（系统的预期日常压力）情况下，能够稳定运行的时间。
<p>因为稳定性测试运行时间长，通常至少连续运行24小时以上，所以平时手工测试或短时间性能测试发现不了的问题，可以在该类型的性能测试过程中发现，如：内存泄漏问题等。</p></li></ol>
<p>计算公式：</p>
<p>吞吐量 　</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467375/201904/1467375-20190419095029744-2054268091.png" /></p>
<p>　并发数　　</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467375/201904/1467375-20190419095054940-338432264.png" /></p>
<p>思考时间</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1467375/201904/1467375-20190419095105073-2068225466.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvve0zq.html">MySQL主从复制&lpar;Master-Slave&rpar;实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/m960kl49.html">利用Shell脚本将MySQL表中的数据转化为json格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2ok08.html">【Auto Layout】Xcode6及以上版本，创建Auto Layout 约束时产生的一些变化【iOS开发教程】</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932w4gq.html">laravel 加中间件的方法 防止直接打开后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/49goz4lq.html">Bootstrap 我的学习记录4 轮播图的使用和理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzokd8.html">【leetcode❤python】342&period; Power of Four</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e112jm9.html">浏览器编码的函数简介escape&lpar;&rpar;&comma;encodeURI&lpar;&rpar;&comma;encodeURIComponent&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0lndlq.html">【windows核心编程】 第八章  用户模式下的线程同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnk408.html">一台Ubuntu server上安装多实例MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zogx73q.html">java-finalize</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvm6g8.html">Merge into的使用详解-你Merge了没有</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zjp039.html">客户端程序通过TCP通信传送&amp;quot&semi;小文件&amp;quot&semi;到服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyke0m9.html">&lbrack;SHOI2008&rsqb;cactus仙人掌图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mp3j9.html">P3690 【模板】Link Cut Tree （动态树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkozd38.html">（转）Unity3D 游戏贴图（法线贴图，漫反射贴图，高光贴图）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpzg5z9.html">Java实验案例（接口）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql123j69.html">EMC测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvpmjjq.html">Mongodb数据导出工具mongoexport和导入工具mongoimport使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk5y0n8.html">源码分析HotSpot GC过程&lpar;二&rpar;：DefNewGeneration的GC过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2rpwg9.html">Redis 连接失败redis Can&amp;&num;39&semi;t init enough connections amount&excl;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj6lxe9.html">增加swap分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6jvo8.html">git在项目中的实际运用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1401oq.html">Shell执行&ast;&period;sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpx5v79.html">java 静态代理模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me1p60q.html">使用Set集合对List集合进行去重</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgv15d8.html">2018-2019-2 网络对抗技术 20165328 Exp5 MSF基础应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1z5yjq.html">python的学习之路（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k1ykz9.html">https和http 调用过程中请求头 referrer 获取不到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk760v8.html">Final Cut Pro X for Mac&lpar;FCPX专业视频剪辑工具&rpar;实用技巧篇！</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me1rmoq.html">Codeforces 581F Zublicanes and Mumocrates  树形dp</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
